<?xml version="1.0" encoding="UTF-8"?>
    <!--
        Author : wixu
    -->
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="html"/>
    
    <xsl:template match="/">

     <!-- Titulo -->
     <xsl:for-each select="//titulo">
         <title><div align="center"><span style="color:#B22222;"><i><b>Documento ER</b></i></span></div></title>
         <hr></hr>
     </xsl:for-each>
   

    <!-- REQUISITO FUNCIONAL
    -->
    <xsl:for-each select="//Objeto">
        <xsl:if test=" tipo= 'RequisitoFuncional'">
            <br></br>
            <table border="1">
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>FRQ</b></span></td>
                <td><xsl:value-of select="nombre"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Autores</b></span></td>
                <td><xsl:for-each select="./autores"><xsl:value-of select="nombaut"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fuentes</b></span></td>
                <td><xsl:for-each select="./fuentes"><xsl:value-of select="nombfuen"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Dependencias</b></span></td>
                <td><xsl:for-each select="./dependencias"><xsl:value-of select="nombdest"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Descripcion</b></span></td>
                <td><xsl:value-of select="descripcion"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Importancia</b></span></td>
                <td><xsl:value-of select="importancia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Urgencia</b></span></td>
                <td><xsl:value-of select="urgencia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Estado</b></span></td>
                <td><xsl:value-of select="estado"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Estabilidad</b></span></td>
                <td><xsl:value-of select="estabilidad"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Comentarios</b></span></td>
                <td><xsl:value-of select="comentarios"/></td>
            </tr>
            </table><br/>
        </xsl:if>
      <!-- FINAL REQUISITO FUNCIONAL
    -->
    <!-- ***********************************************************************
    -->
        <!-- REQUISITO DE INFORMACION
    -->
        <xsl:if test=" tipo= 'RequisitoInformacion'">
            <br></br>
            <table border="1">
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>IRQ</b></span></td>
                <td><xsl:value-of select="nombre"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Autores</b></span></td>
                <td><xsl:for-each select="./autores"><xsl:value-of select="nombaut"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fuentes</b></span></td>
                 <td><xsl:for-each select="./fuentes"><xsl:value-of select="nombfuen"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Dependencias</b></span></td>
                 <td><xsl:for-each select="./dependencias"><xsl:value-of select="nombdest"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Descripcion</b></span></td>
                <td><xsl:value-of select="descripcion"/></td>
            </tr>
            <!-- Dentro de cada REQUISITO DE INFORMACION está DATOS ESPECIFICOS
            -->
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Datos Especificos</b></span></td>
                <td><xsl:for-each select="datosEspecificos"><xsl:value-of select="nombdat"/><br/></xsl:for-each></td>
            </tr>
            <!-- FIN DE DATOS ESPECIFICOS
            -->
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Tiempo de vida</b></span></td>
                <td><b>Medio</b><br></br>
                <xsl:value-of select="tmedio"/><hr></hr>
                <b>Maximo</b><br></br>
                <xsl:value-of select="tmaximo"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Ocurrencias simultaneas</b></span></td>
                <td><b>Medio</b><br></br>
                <xsl:value-of select="medio"/>
                <hr></hr>
                <b>Maximo</b><br></br>
                <xsl:value-of select="maximo"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Importancia</b></span></td>
                <td><xsl:value-of select="importancia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Urgencia</b></span></td>
                <td><xsl:value-of select="urgencia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Estado</b></span></td>
                <td><xsl:value-of select="estado"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Estabilidad</b></span></td>
                <td><xsl:value-of select="estabilidad"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Comentarios</b></span></td>
                <td><xsl:value-of select="comentarios"/></td>
            </tr>
            </table>
            <br></br>
        </xsl:if>
    <!-- FINAL REQUISITO DE INFORMACION
    -->
    <!-- ***********************************************************************
    -->
     <!-- REQUISITO NO FUNCIONAL
    -->
        <xsl:if test=" tipo= 'RequisitoNoFuncional'">
            <br></br>
            <table border="1">
            <tr>
            <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>NFRQ</b></span></td>
            <td><xsl:value-of select="nombre"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Autores</b></span></td>
                <td><xsl:for-each select="./autores"><xsl:value-of select="nombaut"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fuentes</b></span></td>
                <td><xsl:for-each select="./fuentes"><xsl:value-of select="nombfuen"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Dependencias</b></span></td>
                <td><xsl:for-each select="./dependencias"><xsl:value-of select="nombdest"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Descripcion</b></span></td>
                <td><xsl:value-of select="descripcion"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Importancia</b></span></td>
                <td><xsl:value-of select="importancia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Urgencia</b></span></td>
                <td><xsl:value-of select="urgencia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Estado</b></span></td>
                <td><xsl:value-of select="estado"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Estabilidad</b></span></td>
                <td><xsl:value-of select="estabilidad"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Comentarios</b></span></td>
                <td><xsl:value-of select="comentarios"/></td>
            </tr>
            </table>
            <br></br>
        </xsl:if>
    <!-- FINAL REQUISITO NO FUNCIONAL
    -->
    <!-- ***********************************************************************
    -->
     <!-- REUNION
    -->
        <xsl:if test=" tipo= 'Reunion'">
            <table border="1">
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>REU</b></span></td>
                <td><xsl:value-of select="nombre"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Autores</b></span></td>
                <td><xsl:for-each select="./autores"><xsl:value-of select="nombaut"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fuentes</b></span></td>
                <td><xsl:for-each select="./fuentes"><xsl:value-of select="nombfuen"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Lugar</b></span></td>
                <td><xsl:value-of select="lugar"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fecha</b></span></td>
                <td><xsl:value-of select="fecha"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Resultado</b></span></td>
                <td><xsl:value-of select="resultado"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Asistentes</b></span></td>
                <td><xsl:for-each select="asistentes"><xsl:value-of select="nombasist"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Comentarios</b></span></td>
                <td><xsl:value-of select="comentarios"/></td>
            </tr>
            </table>
            <br></br>
        </xsl:if>
     <!-- FINAL REUNION
    -->
    <!-- ***********************************************************************
    -->

     <!-- PARTICIPANTE
    -->
        <xsl:if test=" tipo= 'Participante'">
            <table border="1">
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>PAR</b></span></td>
                <td><xsl:value-of select="nombre"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Rol</b></span></td>
                <td><xsl:value-of select="rol"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Autores</b></span></td>
                <td><xsl:for-each select="./autores"><xsl:value-of select="nombaut"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fuentes</b></span></td>
                <td><xsl:for-each select="./fuentes"><xsl:value-of select="nombfuen"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Cliente</b></span></td>
                <td><xsl:value-of select="cliente"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Desarrollador</b></span></td>
                <td><xsl:value-of select="desarrollador"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Usuario</b></span></td>
                <td><xsl:value-of select="usuario"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Organizacion</b></span></td>
                <td><xsl:value-of select="Porganizacion"/></td>
            </tr>

            </table>
            <br></br>
        </xsl:if>
    <!-- FINAL PARTICIPANTE
    -->
    <!-- ***********************************************************************
    -->

    <!-- ORGANIZACION
    -->
        <xsl:if test=" tipo= 'Organizacion'">
            <table border="1">
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>ORG</b></span></td>
                <td><xsl:value-of select="nombre"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Autores</b></span></td>
                <td><xsl:for-each select="./autores"><xsl:value-of select="nombaut"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fuentes</b></span></td>
                <td><xsl:for-each select="./fuentes"><xsl:value-of select="nombfuen"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Direccion</b></span></td>
                <td><xsl:value-of select="direccion"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Telefono</b></span></td>
                <td><xsl:value-of select="telefono"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fax</b></span></td>
                <td><xsl:value-of select="fax"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Participantes asociados</b></span></td>
                <td><xsl:for-each select="participantes"><xsl:value-of select="nombpart"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Comentarios</b></span></td>
                <td><xsl:value-of select="comentarios"/></td>
            </tr>
            </table>
            <br></br>
        </xsl:if>
    <!-- FINAL ORGANIZACION
    -->
    <!-- ***********************************************************************
    -->
      <!-- OBJETIVO
    -->
        <xsl:if test="tipo= 'Objetivo'">
            <br></br>
            <table border="1">
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>OBJ</b></span></td>
                <td><xsl:value-of select="nombre"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Autores</b></span></td>
                <td><xsl:for-each select="./autores"><xsl:value-of select="nombaut"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fuentes</b></span></td>
                <td><xsl:for-each select="./fuentes"><xsl:value-of select="nombfuen"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Dependencias</b></span></td>
                <td><xsl:for-each select="./dependencias"><xsl:value-of select="nombdest"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Descripcion</b></span></td>
                <td><xsl:value-of select="descripcion"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Importancia</b></span></td>
                <td><xsl:value-of select="importancia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Urgencia</b></span></td>
                <td><xsl:value-of select="urgencia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Estado</b></span></td>
                <td><xsl:value-of select="estado"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Estabilidad</b></span></td>
                <td><xsl:value-of select="estabilidad"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Comentarios</b></span></td>
                <td><xsl:value-of select="comentarios"/></td>
            </tr>
            </table>
            <br></br>
        </xsl:if>
    <!-- FINAL OBJETIVO
    -->
    <!-- ***********************************************************************
    -->



    <!-- CASO DE USO
    -->
        <xsl:if test="tipo= 'CasoDeUso'">
            <br></br>
            <table border="1">
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>CU</b></span></td>
                <td><xsl:value-of select="nombre"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Autores</b></span></td>
                <td><xsl:for-each select="./autores"><xsl:value-of select="nombaut"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fuentes</b></span></td>
                <td><xsl:for-each select="./fuentes"><xsl:value-of select="nombfuen"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Dependencias</b></span></td>
                <td><xsl:for-each select="./dependencias"><xsl:value-of select="nombdest"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Descripcion</b></span></td>
                <td><xsl:value-of select="descripcion"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Precondicion</b></span></td>
                <td><xsl:value-of select="precondicion"/></td>
            </tr>
    <!-- Dentro de cada CASO DE USO está PASOS
    -->
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Secuencia normal</b></span></td>
                <td><b>Paso</b><br></br>
                <xsl:for-each select="paso"><xsl:value-of select="nombpaso"/><br/></xsl:for-each>
            </td>
            </tr>
    <!-- FIN DE PASOS
    -->
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Postcondicion</b></span></td>
                <td><xsl:value-of select="postcondicion"/></td>
            </tr>
    <!-- Dentro de cada CASO DE USO con algun PASO está EXCEPCIONES
    -->
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Excepciones</b></span></td>
                <td><xsl:for-each select="excepciones"><xsl:value-of select="nombexc"/><br/></xsl:for-each></td>
            </tr>
    <!-- FIN DE EXCEPCIONES
    -->
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Rendimiento</b></span></td>
                <td><b>Tiempo maximo</b><br></br>
                <xsl:for-each select ="Rmaximo"><xsl:value-of select="nombRmax"/><br/></xsl:for-each>
                </td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Frecuencia esperada</b></span></td>
                <td><xsl:value-of select="frecuencia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Importancia</b></span></td>
                <td><xsl:value-of select="importancia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Urgencia</b></span></td>
                <td><xsl:value-of select="urgencia"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Estado</b></span></td>
                <td><xsl:value-of select="estado"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Estabilidad</b></span></td>
                <td><xsl:value-of select="estabilidad"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Comentarios</b></span></td>
                <td><xsl:value-of select="comentarios"/></td>
            </tr>
            </table>
            <br></br>
        </xsl:if>
    <!-- FINAL CASO DE USO
    -->
    <!-- ***********************************************************************
    -->

    <!-- SECCION
    -->
        <xsl:if test="tipo= 'Seccion'">
            <b><xsl:value-of select="nombre"/></b>
            <br></br>
        </xsl:if>
    <!-- FINAL SECCION
    -->
    <!-- ***********************************************************************
    -->
    <!-- PARRAFO
    -->
        <xsl:if test="tipo= 'Parrafo'">
            <b><xsl:value-of select="nombre"/></b>
            <xsl:value-of select="texto"/>
            <br></br>
        </xsl:if>
    <!-- FINAL PARRAFO
    -->
    <!-- ***********************************************************************
    -->
    <!-- ACTOR
    -->
            <xsl:if test=" tipo= 'Actor'">
            <br></br>
            <table border="1">
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>ACT</b></span></td>
                <td><xsl:value-of select="nombre"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Autores</b></span></td>
                <td><xsl:for-each select="./autores"><xsl:value-of select="nombaut"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Fuentes</b></span></td>
                <td><xsl:for-each select="./fuentes"><xsl:value-of select="nombfuen"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Dependencias</b></span></td>
                <td><xsl:for-each select="./dependencias"><xsl:value-of select="nombdest"/><br/></xsl:for-each></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Representacion</b></span></td>
                <td><xsl:value-of select="representacion"/></td>
            </tr>
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b>Comentarios</b></span></td>
                <td><xsl:value-of select="comentarios"/></td>
            </tr>
            </table><br/>
        </xsl:if>
        <!-- FINAL ACTOR -->
        <!-- ************************************************************-->
        <!-- Matriz -->
        <xsl:if test=" tipo= 'matriz'">
            <br></br>
            <table border="1">
            <tr>
                <td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b><xsl:value-of select="nombre"/></b></span></td>
                 <xsl:for-each select="./columna"><td bgcolor="#E0FFFF"><span style="color:#0000CD;"><b><xsl:value-of select="nomcolum"/></b></span></td> </xsl:for-each>
            </tr>
            <xsl:for-each select="./fila"><tr bgcolor="#E0FFFF"><span style="color:#0000CD;"><b><xsl:value-of select="nomfila"/></b></span>
                <xsl:for-each select="./aux"><td bgcolor="white">
                <xsl:if test="./rastreable= 'si'"><div align="center"><span style="color:red" font-size="76%"><b>↑</b></span></div></xsl:if>
                <xsl:if test="./rastreable= 'no'"></xsl:if>
                </td></xsl:for-each>
            </tr></xsl:for-each>
            </table><br/>
        </xsl:if>
        <!-- FINAL MATRIZ  -->
        <!-- *****************************************************************-->
        <!-- Fichero-->
        <xsl:if test=" tipo= 'fichero'">
            <br></br>
                <img><xsl:attribute name="src"><xsl:value-of select="ruta"/></xsl:attribute></img><br/>
                <b>Fichero:</b><xsl:value-of select="nombre"/>
            <br/>
        </xsl:if>
        <!-- FINAL FICHERO  -->
        <!-- *****************************************************************-->
    </xsl:for-each>
  

  
    </xsl:template>
    </xsl:stylesheet>