package Modelo;

import java.util.ArrayList; 
import java.util.Observable;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.9A3170D6-46A9-826A-FD41-62CCF154D9E0]
// </editor-fold> 

public class DocumentoReq extends Observable{


    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AD2CFA70-6D3B-6112-498A-DFC58CBBEA9E]
    // </editor-fold>
    private String nombre;

    private ArrayList<Elemento_trazable> mCaso_de_uso=new ArrayList();

    private ArrayList<Elemento_trazable> mRequisito_funcional=new ArrayList();

    private ArrayList<Elemento_trazable> mRequisito_Informacion=new ArrayList();

    private ArrayList<Elemento_trazable> mRequisito_noFuncional=new ArrayList();

    private ArrayList<Elemento_trazable> mObjetivo=new ArrayList();

    private ArrayList<Elemento_no_trazable> mParticipante=new ArrayList();

    private ArrayList<Elemento_no_trazable> mOrganizacion= new ArrayList();

    private ArrayList<Elemento_no_trazable> mReunion=new ArrayList();

    private ArrayList<Elemento_no_trazable> mSeccion=new ArrayList();

    private ArrayList<Elemento_trazable> mParrafo=new ArrayList();

    private ArrayList<Elemento_no_trazable> mMatriz=new ArrayList();

    private ArrayList<Elemento_trazable> mFichero_grafico = new ArrayList();

    private ArrayList<Elemento_trazable> mActor =new ArrayList();
    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,id=DCE.9E78B0E9-53A7-5C64-1340-81339CAE97DD]
    // </editor-fold> 
    public DocumentoReq () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.146E6F51-B37B-C9F7-80C6-5D93847A1307]
    // </editor-fold> 
    public Caso_de_uso crearCU (String nombreCU, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente,String importancia,String urgencia, String estadodeDesarrollo,String estabilidad,boolean esAbstracto,String eventoActivacion, int frecuencia, String unidadFrecuencia, String precondicion, String postcondicion, ArrayList<Elemento_trazable> dest, ArrayList<Elemento_trazable> orig) {
                //// Creo la instancia
        Caso_de_uso auxCU=new Caso_de_uso();
        //// Asigno los valores a los atributos
        auxCU.setNombre(nombreCU);
        auxCU.setComentario(comentario);
        auxCU.setMAutor(autor);
        auxCU.setMFuente(fuente);
        auxCU.setImportancia(importancia);
        auxCU.setUrgencia(urgencia);
        auxCU.setEstadodeDesarrollo(estadodeDesarrollo);
        auxCU.setEstabilidad(estabilidad);
        auxCU.setEsAbstracto(esAbstracto);
        auxCU.setEventoActivacion(eventoActivacion);
        auxCU.setFrecuencia(frecuencia);
        auxCU.setUnidadFrecuencia(unidadFrecuencia);
        auxCU.setPrecondicion(precondicion);
        auxCU.setPostcondicion(postcondicion);
        auxCU.setMDestino(dest);
        auxCU.setMOrigen(orig);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getCaso_de_uso().add(auxCU);
        setChanged();
        notifyObservers();
        return auxCU;
    }

    public Elemento_trazable buscarporNombreCU (String nombre){
        int i=0;
        boolean enc=false;
        while(!enc && i<this.getCaso_de_uso().size()){
            if(this.getCaso_de_uso().get(i).getNombre().equals(nombre)){
                enc=true;
            }
            else{i++;}
        }
        if(enc) return this.getCaso_de_uso().get(i);
        else return null;
       
    }
    public Elemento_trazable buscarporNombreRI (String nombre){
        int i=0;
        boolean enc=false;
        while(!enc && i<this.getMRequisito_Informacion().size()){
            if(this.getMRequisito_Informacion().get(i).getNombre().equals(nombre)){
                enc=true;
            }
            else{i++;}
        }
        if(enc) return this.getMRequisito_Informacion().get(i);
        else return null;

    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.80173724-3F8F-EF4A-D99E-15817CA65636]
    // </editor-fold> 
    public ArrayList<Elemento_trazable> getCaso_de_uso () {
        return mCaso_de_uso;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.DD623546-2AFE-4D5B-5D3A-03A0B28B6761]
    // </editor-fold> 
    public void setCaso_de_uso (ArrayList<Elemento_trazable> val) {
        this.mCaso_de_uso = val;
    }

    /**
     * @return the mRequisito_funcional
     */
    public ArrayList<Elemento_trazable> getMRequisito_funcional() {
        return mRequisito_funcional;
    }

    /**
     * @param mRequisito_funcional the mRequisito_funcional to set
     */
    public void setMRequisito_funcional(ArrayList<Elemento_trazable> mRequisito_funcional) {
        this.mRequisito_funcional = mRequisito_funcional;
    }

    public Req_funcional crearReqFuncional(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente, String descripcion, String importancia, String urgencia, String est_desarrollo, String estabilidad, ArrayList<Elemento_trazable> dest, ArrayList<Elemento_trazable> orig){
        Req_funcional rF= new Req_funcional();

        rF.setNombre(nombre);
        rF.setComentario(comentario);
        rF.setMAutor(autor);
        rF.setMFuente(fuente);
        rF.setDescripcion(descripcion);
        rF.setImportancia(importancia);
        rF.setUrgencia(urgencia);
        rF.setEstadodeDesarrollo(est_desarrollo);
        rF.setEstabilidad(estabilidad);
        rF.setMDestino(dest);
        rF.setMOrigen(orig);
        this.getMRequisito_funcional().add(rF);
        setChanged();
        notifyObservers();

        return rF;
    }

    /**
     * @return the mRequisito_Informacion
     */
    public ArrayList<Elemento_trazable> getMRequisito_Informacion() {
        return mRequisito_Informacion;
    }

    /**
     * @param mRequisito_Informacion the mRequisito_Informacion to set
     */
    public void setMRequisito_Informacion(ArrayList<Elemento_trazable> mRequisito_Informacion) {
        this.mRequisito_Informacion = mRequisito_Informacion;
    }

    public Req_informacion crearReqInformacion(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente, String descripcion, int tMaxValor, String tMaxUnidad, int tMedValor, String tMedUnidad, int nMax, int nMed, String importancia, String urgencia, String est_desarrollo, String estabilidad, ArrayList<Elemento_trazable> dest, ArrayList<Elemento_trazable> orig){
        Req_informacion rI= new Req_informacion();

        rI.setNombre(nombre);
        rI.setComentario(comentario);
        rI.setMAutor(autor);
        rI.setMFuente(fuente);
        rI.setTiempMaxVida_Valor(tMaxValor);
        rI.setTiempoMaxVida_Unidad(tMaxUnidad);
        rI.setTiempoMedVida_Valor(tMedValor);
        rI.setTiempoMedVida_Unidad(tMedUnidad);
        rI.setNMax(nMax);
        rI.setNMed(nMed);
        rI.setDescripcion(descripcion);
        rI.setImportancia(importancia);
        rI.setUrgencia(urgencia);
        rI.setEstadodeDesarrollo(est_desarrollo);
        rI.setEstabilidad(estabilidad);
        rI.setMDestino(dest);
        rI.setMOrigen(orig);
        this.mRequisito_Informacion.add(rI);
        setChanged();
        notifyObservers();
        return rI;
    }

    /**
     * @return the mRequisito_noFuncioanl
     */
    public ArrayList<Elemento_trazable> getMRequisito_noFuncional() {
        return mRequisito_noFuncional;
    }

    /**
     * @param mRequisito_noFuncioanl the mRequisito_noFuncional to set
     */
    public void setMRequisito_noFuncional(ArrayList<Elemento_trazable> mRequisito_noFuncional) {
        this.mRequisito_noFuncional = mRequisito_noFuncional;
    }

    public Requisito_no_funcional crearRequisito_noFuncional(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente, String descripcion,String importancia, String urgencia, String est_desarrollo, String estabilidad, ArrayList<Elemento_trazable> dest, ArrayList<Elemento_trazable> orig){
        Requisito_no_funcional rnF= new Requisito_no_funcional();

        rnF.setNombre(nombre);
        rnF.setComentario(comentario);
        rnF.setMAutor(autor);
        rnF.setMFuente(fuente);
        rnF.setDescripcion(descripcion);
        rnF.setImportancia(importancia);
        rnF.setUrgencia(urgencia);
        rnF.setEstadodeDesarrollo(est_desarrollo);
        rnF.setEstabilidad(estabilidad);
        rnF.setMDestino(dest);
        rnF.setMOrigen(orig);
        this.getMRequisito_funcional().add(rnF);
        setChanged();
        notifyObservers();
        
        return rnF;
    }

    public ArrayList<Elemento_trazable> getMObjetivo() {
        return mObjetivo;
    }

    public void setMObjetivo(ArrayList<Elemento_trazable> mObjetivo) {
        this.mObjetivo = mObjetivo;

    }

    public Objetivo crearObjetivo(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente, String descripcion,String importancia, String urgencia, String est_desarrollo, String estabilidad, ArrayList<Elemento_trazable> dest, ArrayList<Elemento_trazable> orig){
        Objetivo ob= new Objetivo();

        ob.setNombre(nombre);
        ob.setComentario(comentario);
        ob.setMAutor(autor);
        ob.setMFuente(fuente);
        ob.setDescripcion(descripcion);
        ob.setImportancia(importancia);
        ob.setUrgencia(urgencia);
        ob.setEstadodeDesarrollo(est_desarrollo);
        ob.setEstabilidad(estabilidad);
        ob.setMDestino(dest);
        ob.setMOrigen(orig);
        this.getMObjetivo().add(ob);
        setChanged();
        notifyObservers();

        return ob;
    }

    /**
     * @return the mParticipante
     */
    public ArrayList<Elemento_no_trazable> getMParticipante() {
        return mParticipante;
    }

    /**
     * @param mParticipante the mParticipante to set
     */
    public void setMParticipante(ArrayList<Elemento_no_trazable> mParticipante) {
        this.mParticipante = mParticipante;
    }

    public Participante crearParticipante(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente,String rol, boolean esCliente, boolean esDesarrollador, boolean esUsuario, String org){
        Participante p=new Participante();

        p.setNombre(nombre);
        p.setComentario(comentario);
        p.setMAutor(autor);
        p.setMFuente(fuente);
        p.setRol(rol);
        p.setEsCliente(esCliente);
        p.setEsDesarrollador(esDesarrollador);
        p.setEsUsuario(esUsuario);
        p.setOrganizacion(org);

        this.getMParticipante().add(p);
        setChanged();
        notifyObservers();
        
        return p;


    }
    public Organizacion crearOrganizacion(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente,String dir, String tlf, String fax){
        Organizacion o=new Organizacion();
        
        o.setNombre(nombre);
        o.setComentario(comentario);
        o.setMAutor(autor);
        o.setMFuente(fuente);
        o.setDireccion(dir);
        o.setTelefono(tlf);
        o.setFax(fax);
        
        this.getMOrganizacion().add(o);
        setChanged();
        notifyObservers();
        
        return o;

    }

    /**
     * @return the mOrganizacion
     */
    public ArrayList<Elemento_no_trazable> getMOrganizacion() {
        return mOrganizacion;
    }

    /**
     * @param mOrganizacion the mOrganizacion to set
     */
    public void setMOrganizacion(ArrayList<Elemento_no_trazable> mOrganizacion) {
        this.mOrganizacion = mOrganizacion;
    }

    /**
     * @return the mReunion
     */
    public ArrayList<Elemento_no_trazable> getMReunion() {
        return mReunion;
    }

    /**
     * @param mReunion the mReunion to set
     */
    public void setMReunion(ArrayList<Elemento_no_trazable> mReunion) {
        this.mReunion = mReunion;
    }

    public Reunion crearReunion(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente,String lugar, String fecha, String resultados,ArrayList<Participante> asist){
        Reunion r=new Reunion();

        r.setNombre(nombre);
        r.setComentario(comentario);
        r.setMAutor(autor);
        r.setMFuente(fuente);
        r.setLugar(lugar);
        r.setFecha(fecha);
        r.setResultados(resultados);
        r.setMAsistentes(asist);
        this.getMReunion().add(r);
        setChanged();
        notifyObservers();

        return r;
    }

public void toXML(Object o,Result result,Document document,Element raiz){


        Element nodo = document.createElement("Objeto");
        Element tipo = document.createElement("tipo");
        if(o instanceof Req_funcional){
                 Req_funcional rf=(Req_funcional) o;
                 tipo.appendChild(document.createTextNode("RequisitoFuncional"));
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(rf.getNombre());
                 Element e4=document.createElement("descripcion");
                 Text t4= document.createTextNode("El sistema deberá "+rf.getDescripcion());
                 Element e5=document.createElement("importancia");
                 Text t5= document.createTextNode(rf.getImportancia());
                 Element e6=document.createElement("urgencia");
                 Text t6= document.createTextNode(rf.getUrgencia());
                 Element e7=document.createElement("estado");
                 Text t7= document.createTextNode(rf.getEstadodeDesarrollo());
                 Element e8=document.createElement("estabilidad");
                 Text t8= document.createTextNode(rf.getEstabilidad());
                 Element e9=document.createElement("comentarios");
                 Text t9= document.createTextNode(rf.getComentario());

                 e1.appendChild(t1);
                 for(int i=0; i<rf.getMAutor().size();i++){
                     Element e2=document.createElement("autores");
                     Element autor=document.createElement("nombaut");
                     Text t2= document.createTextNode(rf.getMAutor().get(i).getNombre());
                     autor.appendChild(t2);
                     e2.appendChild(autor);
                     nodo.appendChild(e2);
                 }
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 e6.appendChild(t6);
                 e7.appendChild(t7);
                 e8.appendChild(t8);
                 e9.appendChild(t9);
                for(int i=0; i<rf.getMFuente().size();i++){
                     Element e10=document.createElement("fuentes");
                     Element fuente=document.createElement("nombfuen");
                     Text t10= document.createTextNode(rf.getMFuente().get(i).getNombre());
                     fuente.appendChild(t10);
                     e10.appendChild(fuente);
                     nodo.appendChild(e10);
                 }
                  for(int i=0; i<rf.getMDestino().size();i++){
                     Element e3=document.createElement("dependencias");
                     Element dependencia=document.createElement("nombdest");
                     Text t11= document.createTextNode(rf.getMFuente().get(i).getNombre());
                     dependencia.appendChild(t11);
                     e3.appendChild(dependencia);
                     nodo.appendChild(e3);
                 }

                 nodo.appendChild(e1);
                 nodo.appendChild(e4);
                 nodo.appendChild(e5);
                 nodo.appendChild(e6);
                 nodo.appendChild(e7);
                 nodo.appendChild(e8);
                 nodo.appendChild(e9);
                 nodo.appendChild(tipo);
                 raiz.appendChild(nodo);

            }

            else if(o instanceof Req_informacion){
                 Req_informacion rfi=(Req_informacion) o;
                 tipo.appendChild(document.createTextNode("RequisitoInformacion"));
                 Element ee1=document.createElement("nombre");
                 Text tt1= document.createTextNode(rfi.getNombre());
                 Element ee4=document.createElement("descripcion");
                 Text tt4= document.createTextNode(rfi.getDescripcion());
                 Element ee5=document.createElement("importancia");
                 Text tt5= document.createTextNode(rfi.getImportancia());
                 Element ee6=document.createElement("urgencia");
                 Text tt6= document.createTextNode(rfi.getUrgencia());
                 Element ee7=document.createElement("estado");
                 Text tt7= document.createTextNode(rfi.getEstadodeDesarrollo());
                 Element ee8=document.createElement("estabilidad");
                 Text tt8= document.createTextNode(rfi.getEstabilidad());
                 Element ee9=document.createElement("comentarios");
                 Text tt9= document.createTextNode(rfi.getComentario());
                 Element ee10=document.createElement("tmaximo");
                 Text tt10= document.createTextNode(String.valueOf(rfi.getTiempMaxVida_Valor())+" "+rfi.getTiempoMaxVida_Unidad());
                 Element ee11=document.createElement("tmedio");
                 Text tt11= document.createTextNode(String.valueOf(rfi.getTiempoMedVida_Valor())+" "+rfi.getTiempoMedVida_Unidad());
                 Element ee12=document.createElement("medio");
                 Text tt12= document.createTextNode(String.valueOf(rfi.getNMed()));
                 Element ee13=document.createElement("maximo");
                 Text tt13= document.createTextNode(String.valueOf(rfi.getNMax()));

                 ee1.appendChild(tt1);
                 for(int i=0; i<rfi.getMAutor().size();i++){
                     Element e2=document.createElement("autores");
                     Element autor=document.createElement("nombaut");
                     Text t2= document.createTextNode(rfi.getMAutor().get(i).getNombre());
                     autor.appendChild(t2);
                     e2.appendChild(autor);
                     nodo.appendChild(e2);
                 }
                 ee4.appendChild(tt4);
                 ee5.appendChild(tt5);
                 ee6.appendChild(tt6);
                 ee7.appendChild(tt7);
                 ee8.appendChild(tt8);
                 ee9.appendChild(tt9);
                for(int i=0; i<rfi.getMFuente().size();i++){
                     Element e10=document.createElement("fuentes");
                     Element fuente=document.createElement("nombfuen");
                     Text t10= document.createTextNode(rfi.getMFuente().get(i).getNombre());
                     fuente.appendChild(t10);
                     e10.appendChild(fuente);
                     nodo.appendChild(e10);
                 }
                  for(int i=0; i<rfi.getMDestino().size();i++){
                     Element e3=document.createElement("dependencias");
                     Element dependencia=document.createElement("nombdest");
                     Text t11= document.createTextNode(rfi.getMDestino().get(i).getNombre());
                     dependencia.appendChild(t11);
                     e3.appendChild(dependencia);
                     nodo.appendChild(e3);
                 }
                 ee10.appendChild(tt10);
                 ee11.appendChild(tt11);
                 ee12.appendChild(tt12);
                 ee13.appendChild(tt13);
                 for(int i=0; i<rfi.getDato_Especifico().size();i++){
                    Element ee14=document.createElement("datosEspecificos");
                    Element dato=document.createElement("nombdat");
                    Text t14= document.createTextNode(rfi.getDato_Especifico().get(i).getDescripcion());
                    dato.appendChild(t14);
                    ee14.appendChild(dato);
                    nodo.appendChild(ee14);
                 }

                 nodo.appendChild(ee1);
                 nodo.appendChild(ee4);
                 nodo.appendChild(ee5);
                 nodo.appendChild(ee6);
                 nodo.appendChild(ee7);
                 nodo.appendChild(ee8);
                 nodo.appendChild(ee9);
                 nodo.appendChild(ee10);
                 nodo.appendChild(ee11);
                 nodo.appendChild(ee12);
                 nodo.appendChild(ee13);
                 nodo.appendChild(tipo);
                 raiz.appendChild(nodo);

            }

            //hay que mirar y añadir "Excepcion", "Paso", Abstracto y demás
            else if(o instanceof Caso_de_uso){
                Caso_de_uso cdu=(Caso_de_uso) o;
                tipo.appendChild(document.createTextNode("CasoDeUso"));
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(cdu.getNombre());
                 Element e4=document.createElement("descripcion");
                 Text t4;
                 if(cdu.getEsAbstracto()){t4= document.createTextNode("El sistema deberá comportarse tal como se describe en el siguiente caso de uso abstracto durante la realización de los siguientes casos de uso");}
                 else { t4= document.createTextNode("El sistema deberá comportarse tal como se describe en el siguiente caso de uso cuando "+cdu.getEventoActivacion());}
                 Element e5=document.createElement("importancia");
                 Text t5= document.createTextNode(cdu.getImportancia());
                 Element e6=document.createElement("urgencia");
                 Text t6= document.createTextNode(cdu.getUrgencia());
                 Element e7=document.createElement("estado");
                 Text t7= document.createTextNode(cdu.getEstadodeDesarrollo());
                 Element e8=document.createElement("estabilidad");
                 Text t8= document.createTextNode(cdu.getEstabilidad());
                 Element e9=document.createElement("comentarios");
                 Text t9= document.createTextNode(cdu.getComentario());
                 Element e11=document.createElement("precondicion");
                 Text t11= document.createTextNode(cdu.getPrecondicion());
                 Element e12=document.createElement("postcondicion");
                 Text t12= document.createTextNode(cdu.getPostcondicion());

                 e1.appendChild(t1);
                for(int i=0; i<cdu.getMAutor().size();i++){
                     Element e2=document.createElement("autores");
                     Element autor=document.createElement("nombaut");
                     Text t2= document.createTextNode(cdu.getMAutor().get(i).getNombre());
                     autor.appendChild(t2);
                     e2.appendChild(autor);
                     nodo.appendChild(e2);
                 }
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 e6.appendChild(t6);
                 e7.appendChild(t7);
                 e8.appendChild(t8);
                 e9.appendChild(t9);
                for(int i=0; i<cdu.getMFuente().size();i++){
                     Element e10=document.createElement("fuentes");
                     Element fuente=document.createElement("nombfuen");
                     Text t10= document.createTextNode(cdu.getMFuente().get(i).getNombre());
                     fuente.appendChild(t10);
                     e10.appendChild(fuente);
                     nodo.appendChild(e10);
                 }
                  for(int i=0; i<cdu.getMDestino().size();i++){
                     Element e3=document.createElement("dependencias");
                     Element dependencia=document.createElement("nombdest");
                     Text t13= document.createTextNode(cdu.getMDestino().get(i).getNombre());
                     dependencia.appendChild(t13);
                     e3.appendChild(dependencia);
                     nodo.appendChild(e3);
                 }
                 e11.appendChild(t11);
                 e12.appendChild(t12);
                 for(int i=0; i<cdu.getPaso().size();i++){
                     Element e13= document.createElement("paso");
                     Element e15=document.createElement("Rmaximo");
                     Element paso=document.createElement("nombpaso");
                     Element rmax=document.createElement("nombRmax");
                     Text t13= document.createTextNode(cdu.getPaso().get(i).getDescripcion());
                     paso.appendChild(t13);
                     e13.appendChild(paso);
                     Text t15 =document.createTextNode(cdu.getPaso().get(i).getValorRendimiento()+" "+cdu.getPaso().get(i).getUnidadRendimiento());
                     rmax.appendChild(t15);
                     e15.appendChild(rmax);
                     nodo.appendChild(e13);
                     nodo.appendChild(e15);
                     for(int j=0; j<cdu.getPaso().get(i).getExcepcion().size();j++){
                         Element e14=document.createElement("excepciones");
                         Element exc=document.createElement("nombexc");
                         Text t14= document.createTextNode(cdu.getPaso().get(i).getExcepcion().get(j).getDescripcion());
                         exc.appendChild(t14);
                         e14.appendChild(exc);
                         nodo.appendChild(e14);
                     }
                 }

                 nodo.appendChild(e1);
                 nodo.appendChild(e4);
                 nodo.appendChild(e5);
                 nodo.appendChild(e6);
                 nodo.appendChild(e7);
                 nodo.appendChild(e8);
                 nodo.appendChild(e9);
                 nodo.appendChild(e11);
                 nodo.appendChild(e12);
                 nodo.appendChild(tipo);
                 raiz.appendChild(nodo);
            } 
            else if(o instanceof Requisito_no_funcional){
            Requisito_no_funcional rnf=(Requisito_no_funcional) o;
            tipo.appendChild(document.createTextNode("RequisitoNoFuncional"));
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(rnf.getNombre());
                 Element e4=document.createElement("descripcion");
                 Text t4= document.createTextNode("El sistema deberá "+rnf.getDescripcion());
                 Element e5=document.createElement("importancia");
                 Text t5= document.createTextNode(rnf.getImportancia());
                 Element e6=document.createElement("urgencia");
                 Text t6= document.createTextNode(rnf.getUrgencia());
                 Element e7=document.createElement("estado");
                 Text t7= document.createTextNode(rnf.getEstadodeDesarrollo());
                 Element e8=document.createElement("estabilidad");
                 Text t8= document.createTextNode(rnf.getEstabilidad());
                 Element e9=document.createElement("comentarios");
                 Text t9= document.createTextNode(rnf.getComentario());

                 e1.appendChild(t1);
                for(int i=0; i<rnf.getMAutor().size();i++){
                     Element e2=document.createElement("autores");
                     Element autor=document.createElement("nombaut");
                     Text t2= document.createTextNode(rnf.getMAutor().get(i).getNombre());
                     autor.appendChild(t2);
                     e2.appendChild(autor);
                     nodo.appendChild(e2);
                 }
//                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 e6.appendChild(t6);
                 e7.appendChild(t7);
                 e8.appendChild(t8);
                 e9.appendChild(t9);
                 for(int i=0; i<rnf.getMFuente().size();i++){
                     Element e10=document.createElement("fuentes");
                     Element fuente=document.createElement("nombfuen");
                     Text t10= document.createTextNode(rnf.getMFuente().get(i).getNombre());
                     fuente.appendChild(t10);
                     e10.appendChild(fuente);
                     nodo.appendChild(e10);
                 }
                  for(int i=0; i<rnf.getMDestino().size();i++){
                     Element e3=document.createElement("dependencias");
                     Element dependencia=document.createElement("nombdest");
                     Text t13= document.createTextNode(rnf.getMDestino().get(i).getNombre());
                     dependencia.appendChild(t13);
                     e3.appendChild(dependencia);
                     nodo.appendChild(e3);
                 }

                 nodo.appendChild(e1);
                 nodo.appendChild(e4);
                 nodo.appendChild(e5);
                 nodo.appendChild(e6);
                 nodo.appendChild(e7);
                 nodo.appendChild(e8);
                 nodo.appendChild(e9);
                 nodo.appendChild(tipo);
                 raiz.appendChild(nodo);
            }

            else if(o instanceof Objetivo){
            Objetivo ob=(Objetivo) o;
            tipo.appendChild(document.createTextNode("Objetivo"));
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(ob.getNombre());
                 Element e4=document.createElement("descripcion");
                 Text t4= document.createTextNode("El sistema deberá "+ob.getDescripcion());
                 Element e5=document.createElement("importancia");
                 Text t5= document.createTextNode(ob.getImportancia());
                 Element e6=document.createElement("urgencia");
                 Text t6= document.createTextNode(ob.getUrgencia());
                 Element e7=document.createElement("estado");
                 Text t7= document.createTextNode(ob.getEstadodeDesarrollo());
                 Element e8=document.createElement("estabilidad");
                 Text t8= document.createTextNode(ob.getEstabilidad());
                 Element e9=document.createElement("comentarios");
                 Text t9= document.createTextNode(ob.getComentario());

                 e1.appendChild(t1);
                 for(int i=0; i<ob.getMAutor().size();i++){
                     Element e2=document.createElement("autores");
                     Element autor=document.createElement("nombaut");
                     Text t2= document.createTextNode(ob.getMAutor().get(i).getNombre());
                     autor.appendChild(t2);
                     e2.appendChild(autor);
                     nodo.appendChild(e2);
                 }
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 e6.appendChild(t6);
                 e7.appendChild(t7);
                 e8.appendChild(t8);
                 e9.appendChild(t9);
                 for(int i=0; i<ob.getMFuente().size();i++){
                     Element e10=document.createElement("fuentes");
                     Element fuente=document.createElement("nombfuen");
                     Text t10= document.createTextNode(ob.getMFuente().get(i).getNombre());
                     fuente.appendChild(t10);
                     e10.appendChild(fuente);
                     nodo.appendChild(e10);
                 }
                  for(int i=0; i<ob.getMDestino().size();i++){
                     Element e3=document.createElement("dependencias");
                     Element dependencia=document.createElement("nombdest");
                     Text t13= document.createTextNode(ob.getMDestino().get(i).getNombre());
                     dependencia.appendChild(t13);
                     e3.appendChild(dependencia);
                     nodo.appendChild(e3);
                 }
                 nodo.appendChild(e1);
                 nodo.appendChild(e4);
                 nodo.appendChild(e5);
                 nodo.appendChild(e6);
                 nodo.appendChild(e7);
                 nodo.appendChild(e8);
                 nodo.appendChild(e9);
                 nodo.appendChild(tipo);
                 raiz.appendChild(nodo);
            }

            else if(o instanceof Participante){
                Participante par=(Participante) o;
                tipo.appendChild(document.createTextNode("Participante"));
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(par.getNombre());
                 Element e3=document.createElement("rol");
                 Text t3= document.createTextNode(par.getRol());
                 Element e4=document.createElement("cliente");
                 Text t4,t5,t6;

                 if (par.getEsCliente()){
                 t4= document.createTextNode("Sí.");
                 }
                 else t4= document.createTextNode("No.");
                 Element e5=document.createElement("desarrollador");
                 if(par.getEsDesarrollador()){
                 t5= document.createTextNode("Sí.");
                 }
                 else t5= document.createTextNode("No.");
                 Element e6=document.createElement("usuario");
                 if(par.getEsUsuario()){
                 t6= document.createTextNode("Sí.");
                 }
                 else t6=document.createTextNode("No.");

                 Element e7=document.createElement("comentarios");
                 Text t7= document.createTextNode(par.getComentario());
                 Element e8=document.createElement("Porganizacion");
                 Text t8= document.createTextNode(par.getOrganizacion());

                 e1.appendChild(t1);
                 for(int i=0; i<par.getMFuente().size();i++){
                     Element e10=document.createElement("fuentes");
                     Element fuente=document.createElement("nombfuen");
                     Text t10= document.createTextNode(par.getMFuente().get(i).getNombre());
                     fuente.appendChild(t10);
                     e10.appendChild(fuente);
                     nodo.appendChild(e10);
                 }
                 for(int i=0; i<par.getMAutor().size();i++){
                     Element e2=document.createElement("autores");
                     Element autor=document.createElement("nombaut");
                     Text t2= document.createTextNode(par.getMAutor().get(i).getNombre());
                     autor.appendChild(t2);
                     e2.appendChild(autor);
                     nodo.appendChild(e2);
                 }
                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 e6.appendChild(t6);
                 e7.appendChild(t7);
                 e8.appendChild(t8);

                 nodo.appendChild(e1);
                 nodo.appendChild(e3);
                 nodo.appendChild(e4);
                 nodo.appendChild(e5);
                 nodo.appendChild(e6);
                 nodo.appendChild(e7);
                 nodo.appendChild(e8);
                 nodo.appendChild(tipo);
                 raiz.appendChild(nodo);
            }

            else if(o instanceof Organizacion){
                Organizacion or=(Organizacion) o;
                tipo.appendChild(document.createTextNode("Organizacion"));
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(or.getNombre());
                 Element e3=document.createElement("direccion");
                 Text t3= document.createTextNode(or.getDireccion());
                 Element e4=document.createElement("telefono");
                 Text t4= document.createTextNode(or.getTelefono());
                 Element e5=document.createElement("fax");
                 Text t5= document.createTextNode(or.getFax());

                 Element e7=document.createElement("comentarios");
                 Text t7= document.createTextNode(or.getComentario());

                 e1.appendChild(t1);
                 for(int i=0; i<or.getMAutor().size();i++){
                     Element e2=document.createElement("autores");
                     Element autor=document.createElement("nombaut");
                     Text t2= document.createTextNode(or.getMAutor().get(i).getNombre());
                     autor.appendChild(t2);
                     e2.appendChild(autor);
                     nodo.appendChild(e2);
                 }
                 for(int i=0; i<or.getMFuente().size();i++){
                     Element e10=document.createElement("fuentes");
                     Element fuente=document.createElement("nombfuen");
                     Text t10= document.createTextNode(or.getMFuente().get(i).getNombre());
                     fuente.appendChild(t10);
                     e10.appendChild(fuente);
                     nodo.appendChild(e10);
                 }
                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 for(int i=0; i<or.getPart_Asociados().size();i++){
                     Element e6=document.createElement("participantes");
                     Element part=document.createElement("nombpart");
                     Text t6= document.createTextNode(or.getPart_Asociados().get(i).getNombre());
                     part.appendChild(t6);
                     e6.appendChild(part);
                     nodo.appendChild(e6);
                 }
                 e7.appendChild(t7);
                 nodo.appendChild(e1);
                 nodo.appendChild(e3);
                 nodo.appendChild(e4);
                 nodo.appendChild(e5);
                 nodo.appendChild(e7);
                 nodo.appendChild(tipo);

                 raiz.appendChild(nodo);
            }

            else if(o instanceof Reunion){
                Reunion re=(Reunion) o;
                tipo.appendChild(document.createTextNode("Reunion"));
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(re.getNombre());
                 Element e3=document.createElement("lugar");
                 Text t3= document.createTextNode(re.getLugar());
                 Element e4=document.createElement("fecha");
                 Text t4= document.createTextNode(re.getFecha());
                 Element e5=document.createElement("resultados");
                 Text t5= document.createTextNode(re.getResultados());    
                 Element e7=document.createElement("comentarios");
                 Text t7= document.createTextNode(re.getComentario());

                 e1.appendChild(t1);
                 for(int i=0; i<re.getMAutor().size();i++){
                     Element e2=document.createElement("autores");
                     Element autor=document.createElement("nombaut");
                     Text t2= document.createTextNode(re.getMAutor().get(i).getNombre());
                     autor.appendChild(t2);
                     e2.appendChild(autor);
                     nodo.appendChild(e2);
                 }
                 for(int i=0; i<re.getMFuente().size();i++){
                     Element e10=document.createElement("fuentes");
                     Element fuente=document.createElement("nombfuen");
                     Text t10= document.createTextNode(re.getMFuente().get(i).getNombre());
                     fuente.appendChild(t10);
                     e10.appendChild(fuente);
                     nodo.appendChild(e10);
                 }
                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 for(int i=0; i<re.getMAsistentes().size();i++){
                     Element e6=document.createElement("asistentes");
                     Element asist=document.createElement("nombasist");
                     Text t6= document.createTextNode(re.getMAsistentes().get(i).getNombre());
                     asist.appendChild(t6);
                     e6.appendChild(asist);
                     nodo.appendChild(e6);
                 }
                 e7.appendChild(t7);

                 nodo.appendChild(e1);
                 nodo.appendChild(e3);
                 nodo.appendChild(e4);
                 nodo.appendChild(e5);
                 nodo.appendChild(e7);
                 nodo.appendChild(tipo);
                 raiz.appendChild(nodo);
            }

            else if(o instanceof Seccion){
            Seccion se=(Seccion) o;
            tipo.appendChild(document.createTextNode("Seccion"));
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(se.getNombre());
                 e1.appendChild(t1);
                 nodo.appendChild(e1);
                 nodo.appendChild(tipo);
                 raiz.appendChild(nodo);
            }
            else if(o instanceof Parrafo){
            Parrafo pa=(Parrafo) o;
            tipo.appendChild(document.createTextNode("Parrafo"));
                if(pa.getEsElemGlo()){
                Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(pa.getNombre()+": ");
                 e1.appendChild(t1);
                 nodo.appendChild(e1);
                }
            Element e2=document.createElement("texto");
                 Text t2= document.createTextNode(pa.getTexto());

                 e2.appendChild(t2);
                 nodo.appendChild(e2);
                 nodo.appendChild(tipo);
                 raiz.appendChild(nodo);
            }
            else if(o instanceof Actor){
                Actor act=(Actor) o;
                tipo.appendChild(document.createTextNode("Actor"));
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(act.getNombre());
                 Element e4=document.createElement("comentarios");
                 Text t4= document.createTextNode(act.getComentario());
                 Element e5= document.createElement("representacion");
                 Text t5= document.createTextNode("Este actor representa "+act.getRepresentacion());

                 e1.appendChild(t1);
                 for(int i=0; i<act.getMAutor().size();i++){
                     Element e2=document.createElement("autores");
                     Element autor=document.createElement("nombaut");
                     Text t2= document.createTextNode(act.getMAutor().get(i).getNombre());
                     autor.appendChild(t2);
                     e2.appendChild(autor);
                     nodo.appendChild(e2);
                 }
                 for(int i=0; i<act.getMFuente().size();i++){
                     Element e10=document.createElement("fuentes");
                     Element fuente=document.createElement("nombfuen");
                     Text t10= document.createTextNode(act.getMFuente().get(i).getNombre());
                     fuente.appendChild(t10);
                     e10.appendChild(fuente);
                     nodo.appendChild(e10);
                 }
                  for(int i=0; i<act.getMDestino().size();i++){
                     Element e3=document.createElement("dependencias");
                     Element dependencia=document.createElement("nombdest");
                     Text t13= document.createTextNode(act.getMDestino().get(i).getNombre());
                     dependencia.appendChild(t13);
                     e3.appendChild(dependencia);
                     nodo.appendChild(e3);
                 }

                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 nodo.appendChild(e1);
                 nodo.appendChild(e4);
                 nodo.appendChild(e5);
                 nodo.appendChild(tipo);
                 raiz.appendChild(nodo);
            }

            else if(o instanceof Matriz_de_rastreabilidad){
                 Matriz_de_rastreabilidad m= (Matriz_de_rastreabilidad) o;
                 tipo.appendChild(document.createTextNode("matriz"));
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(m.getNombre());
                 e1.appendChild(t1);
                 nodo.appendChild(e1);
                 nodo.appendChild(tipo);
                 ArrayList<Elemento_trazable> fila=comprobar_tipo(m.getFila());
                 ArrayList<Elemento_trazable> columna=comprobar_tipo(m.getColumna());
                 for(int i=0; i<fila.size();i++){
                     Element e3=document.createElement("fila");
                     Element nfil=document.createElement("nomfila");
                     Text t13= document.createTextNode(fila.get(i).getNombre());
                     nfil.appendChild(t13);
                     e3.appendChild(nfil);
                    for(int j=0; j<columna.size();j++){
                        Element e5=document.createElement("aux");
                        Element rastreable=document.createElement("rastreable");
                        if(columna.get(j).buscarMOrigen(fila.get(i))){
                            Text r= document.createTextNode("si");
                            rastreable.appendChild(r);
                                                                     }
                        else{
                            Text r= document.createTextNode("no");
                            rastreable.appendChild(r);
                            }
                            
                             e5.appendChild(rastreable);
                             e3.appendChild(e5);
//                     Element e4=document.createElement("columna");
//                     Element ncolum=document.createElement("nomcolum");
//                     Text t4= document.createTextNode(columna.get(j).getNombre());
//                     ncolum.appendChild(t4);
//                     e4.appendChild(ncolum);
//                     nodo.appendChild(e4);
                            
                                                      }
                       

                     nodo.appendChild(e3);
                                                             }
                 for(int i=0; i<columna.size();i++){
                     Element e4=document.createElement("columna");
                     Element ncolum=document.createElement("nomcolum");
                     Text t4= document.createTextNode(columna.get(i).getNombre());
                     ncolum.appendChild(t4);
                     e4.appendChild(ncolum);
                     nodo.appendChild(e4);
                                                             }
                 raiz.appendChild(nodo);

                                                           }

            else if(o instanceof Fichero_grafico){
                Fichero_grafico fg = (Fichero_grafico) o;
                tipo.appendChild(document.createTextNode("fichero"));
                Element e1= document.createElement("nombre");
                Text t1= document.createTextNode(fg.getNombre());
                Element e2= document.createElement("ruta");
                Text t2=document.createTextNode("file:///"+fg.getRuta());
                e1.appendChild(t1);
                e2.appendChild(t2);
                nodo.appendChild(e1);
                nodo.appendChild(e2);
                nodo.appendChild(tipo);
                raiz.appendChild(nodo);
            }

            Source source = new DOMSource(document);


            Result console= new StreamResult(System.out);
            try{
            Transformer transformer = TransformerFactory.newInstance().newTransformer();
            transformer.transform(source, result);
            transformer.transform(source, console);
            }
            catch(Exception e){System.out.println(e);}

    }

    /**
     * @return the nombre
     */
    public String getNombre() {
        return nombre;
    }

    /**
     * @param nombre the nombre to set
     */
    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    /**
     * @return the mSeccion
     */
    public ArrayList<Elemento_no_trazable> getMSeccion() {
        return mSeccion;
    }

    /**
     * @param mSeccion the mSeccion to set
     */
    public void setMSeccion(ArrayList<Elemento_no_trazable> mSeccion) {
        this.mSeccion = mSeccion;
    }
    

public Seccion crearSeccion(String nombre, String comentario, ArrayList<Participante> autor,ArrayList<Participante> fuente, boolean apendice){
Seccion s=new Seccion();

        s.setNombre(nombre);
        s.setComentario(comentario);
        s.setMAutor(autor);
        s.setMFuente(fuente);
        s.setEsApendice(apendice);
        this.getMSeccion().add(s);
        setChanged();
        notifyObservers();

        return s;
}

public Parrafo crearParrafo(String nombre, String comentario, ArrayList<Participante> autor,ArrayList<Participante> fuente, boolean esElemGlo, String texto, ArrayList<Elemento_trazable> dest, ArrayList<Elemento_trazable> orig){
Parrafo p=new Parrafo();

        p.setNombre(nombre);
        p.setComentario(comentario);
        p.setMAutor(autor);
        p.setMFuente(fuente);
        p.setEsElemGlo(esElemGlo);
        p.setTexto(texto);
        p.setMDestino(dest);
        p.setMOrigen(orig);
        this.getMParrafo().add(p);
        setChanged();
        notifyObservers();

        return p;
}

    /**
     * @return the mParrafo
     */
    public ArrayList<Elemento_trazable> getMParrafo() {
        return mParrafo;
    }

    /**
     * @param mParrafo the mParrafo to set
     */
    public void setMParrafo(ArrayList<Elemento_trazable> mParrafo) {
        this.mParrafo = mParrafo;
    }

    public Matriz_de_rastreabilidad crearMatriz(String nombre, String comentario, ArrayList<Participante> autor,ArrayList<Participante> fuente, ArrayList<String> filas, ArrayList<String> columnas){
        Matriz_de_rastreabilidad m=new Matriz_de_rastreabilidad();

        m.setNombre(nombre);
        m.setComentario(comentario);
        m.setMAutor(autor);
        m.setMFuente(fuente);
        m.setFila(filas);
        m.setColumna(columnas);
        this.getMMatriz().add(m);
        setChanged();
        notifyObservers();

        return m;
}

    /**
     * @return the mMatriz
     */
    public ArrayList<Elemento_no_trazable> getMMatriz() {
        return mMatriz;
    }

    /**
     * @param mMatriz the mMatriz to set
     */
    public void setMMatriz(ArrayList<Elemento_no_trazable> mMatriz) {
        this.mMatriz = mMatriz;
    }

    /**
     * @return the mFichero_grafico
     */
    public ArrayList<Elemento_trazable> getMFichero_grafico() {
        return mFichero_grafico;
    }

    /**
     * @param mFichero_grafico the mFichero_grafico to set
     */
    public void setMFichero_grafico(ArrayList<Elemento_trazable> mFichero_grafico) {
        this.mFichero_grafico = mFichero_grafico;
    }

    public Fichero_grafico crear_FicheroGrafico(String nombre, String comentario, ArrayList<Participante> autor,ArrayList<Participante> fuente, String ruta, ArrayList<Elemento_trazable> dest, ArrayList<Elemento_trazable> orig){
        Fichero_grafico f=new Fichero_grafico();

        f.setNombre(nombre);
        f.setComentario(comentario);
        f.setMAutor(autor);
        f.setMFuente(fuente);
        f.setRuta(ruta);
        f.setMDestino(dest);
        f.setMOrigen(orig);
        this.getMFichero_grafico().add(f);
        setChanged();
        notifyObservers();

        return f;
}

    /**
     * @return the mActor
     */
    public ArrayList<Elemento_trazable> getMActor() {
        return mActor;
    }

    /**
     * @param mActor the mActor to set
     */
    public void setMActor(ArrayList<Elemento_trazable> mActor) {
        this.mActor = mActor;
    }

    public Actor crear_Actor(String nombre, String comentario, ArrayList<Participante> autor,ArrayList<Participante> fuente,String rep, ArrayList<Elemento_trazable> dest, ArrayList<Elemento_trazable> orig){
        Actor a=new Actor();

        a.setNombre(nombre);
        a.setComentario(comentario);
        a.setMAutor(autor);
        a.setMFuente(fuente);
        a.setRepresentacion(rep);
        a.setMDestino(dest);
        a.setMOrigen(orig);
        this.getMActor().add(a);
        setChanged();
        notifyObservers();

        return a;
    }

    public ArrayList<Elemento_trazable> comprobar_tipo(ArrayList<String> melem){
          ArrayList<Elemento_trazable> resultado= new ArrayList();
          for(int i=0;i<melem.size();i++){
                    if(melem.get(i).contains("Caso de uso")){
                         for(int i2=0; i2<this.getCaso_de_uso().size();i2++){
                                  resultado.add(this.getCaso_de_uso().get(i2));
                                                                         }
                                                            }
                     if(melem.get(i).contains("Requisito de Información")){
                         for(int i2=0; i2<this.getMRequisito_Informacion().size();i2++){
                                  resultado.add(this.getMRequisito_Informacion().get(i2));
                                                                         }
                                                            }
                     if(melem.get(i).contains("Requisito funcional")){
                         for(int i2=0; i2<this.getMRequisito_funcional().size();i2++){
                                  resultado.add(this.getMRequisito_funcional().get(i2));
                                                                         }
                                                            }
                      if(melem.get(i).contains("Requisito no funcional")){
                         for(int i2=0; i2<this.getMRequisito_noFuncional().size();i2++){
                                  resultado.add(this.getMRequisito_noFuncional().get(i2));
                                                                         }
                                                            }
                       if(melem.get(i).contains("Objetivo")){
                         for(int i2=0; i2<this.getMObjetivo().size();i2++){
                                  resultado.add(this.getMObjetivo().get(i2));
                                                                         }
                                                            }
                        if(melem.get(i).contains("Parrafo")){
                         for(int i2=0; i2<this.getMParrafo().size();i2++){
                                  resultado.add(this.getMParrafo().get(i2));
                                                                         }
                                                            }
                        if(melem.get(i).contains("Fichero grafico")){
                         for(int i2=0; i2<this.getMFichero_grafico().size();i2++){
                                  resultado.add(this.getMFichero_grafico().get(i2));
                                                                         }
                                                            }
                        if(melem.get(i).contains("Actor")){
                         for(int i2=0; i2<this.getMActor().size();i2++){
                                  resultado.add(this.getMActor().get(i2));
                                                                         }
                                                            }

                                                      }
          return resultado;
                                                                               }
}

